//    IPS Java Speech Database
//    (c) Copyright 2011
//    Institute of Phonetics and Speech Processing,
//    Ludwig-Maximilians-University, Munich, Germany
//
//
//    This file is part of IPS Java Speech Database
//
//
//    IPS Java Speech Database is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Lesser General Public License as published by
//    the Free Software Foundation, version 3 of the License.
//
//    IPS Java Speech Database is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public License
//    along with IPS Java Speech Database.  If not, see <http://www.gnu.org/licenses/>.

package ipsk.db.speech;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.Entity;
import javax.persistence.Table;

@Entity
@Table(name = "annotation_session")

public class AnnotationSession implements Serializable {

	protected int annotationSessionId;
	protected String name;
	protected String description;
	protected String type;
	protected Account annotator = null;//ManyToOne
	protected Set<AnnotationGroup> annotations = new HashSet<AnnotationGroup>(0);//OneToMany
	protected AnnotationProject project = null;
	
	/** default constructor */
	public AnnotationSession(){
	}
	
	/** minimal constructor */
	public AnnotationSession(int annotationSessionId){
		this.annotationSessionId = annotationSessionId;
	}
	
	public AnnotationSession(AnnotationSession source){
		this();
		merge(source);
	}

	protected void merge(AnnotationSession source) {
		this.annotationSessionId = source.annotationSessionId;
		this.name = source.name;
		this.description = source.description;
		this.type = source.type;
		this.annotator = source.annotator;
		this.annotations = source.annotations;
		this.project = source.project;
	}
	
	public String toString(){
		String name = "ipsk.db.speech.AnnotationSession";
		if(annotationSessionId==0){
			name = name.concat("-");
		} else {
			name = name.concat(Integer.toString(annotationSessionId));
		}
		name = name.concat("["+ type +"]:" + name + ")");
		return name;
	}
}
